; 
    include \masm32\include\masm32rt.inc
; 

comment * --------------------------------------------------------

                         Build this utility with
                       "CONSOLE ASSEMBLE AND LINK"

        This utility recurses the directory tree from the specified
        directory on the command line and deletes all files and
        directories including the directory specified on the
        command line.

        -------------------------------------------------------- *

    scan_files  PROTO :DWORD
    file_delete PROTO :DWORD

    .code

start:
   
; 

    call main

    exit

; 

main proc

    LOCAL pbuf  :DWORD
    LOCAL cdir  :DWORD
    LOCAL buffer1[128]:BYTE
    LOCAL buffer2[260]:BYTE

    mov pbuf, ptr$(buffer1)
    mov cdir, ptr$(buffer2)

    invoke GetCurrentDirectory,260,cdir

    invoke GetCL,1,pbuf
    .if eax != 1
      print "No Command Line",13,10
      call help
      ret
    .endif

    .if rv(exist,pbuf) != 0
      invoke SetCurrentDirectory,pbuf
      test eax, eax
      jnz @F
      print "Unable to change to target directory",13,10
      call help
      ret
    @@:

    .else
      print "Cannot find target directory",13,10
      call help
      ret
    .endif

    invoke scan_files,0
    invoke scan_files,0

    chdir cdir

    rmdir pbuf

    ret

main endp

; 

scan_files proc flag:DWORD

    LOCAL hSrch :DWORD
    LOCAL wfd   :WIN32_FIND_DATA
    LOCAL pbuf  :DWORD
    LOCAL buffer[260]:BYTE

    add flag, 1

    mov pbuf, ptr$(buffer)

    mov hSrch, rv(FindFirstFile,"*.*",ADDR wfd)
        invoke SetFileAttributes,ADDR wfd.cFileName,FILE_ATTRIBUTE_NORMAL	
    .if hSrch != INVALID_HANDLE_VALUE
      lea eax, wfd.cFileName
      switch$ eax
        case$ "."                           ; bypass current directory character
          jmp @F
      endsw$
      .if wfd.dwFileAttributes == FILE_ATTRIBUTE_DIRECTORY
        invoke szCopy,ADDR wfd.cFileName,pbuf
        chdir ADDR wfd.cFileName
        fn scan_files,flag                  ; recurse to next directory level
        rmdir pbuf
      .endif
      invoke file_delete,ADDR wfd.cFileName

    @@:
      test rv(FindNextFile,hSrch,ADDR wfd), eax
      jz close_file
      invoke SetFileAttributes,ADDR wfd.cFileName,FILE_ATTRIBUTE_NORMAL	
      lea eax, wfd.cFileName
      switch$ eax
        case$ ".."                          ; bypass previous directory characters
          jmp @F
      endsw$
      .if wfd.dwFileAttributes == FILE_ATTRIBUTE_DIRECTORY
        invoke szCopy,ADDR wfd.cFileName,pbuf
        chdir ADDR wfd.cFileName
        fn scan_files,flag                  ; recurse to next directory level
        rmdir pbuf
      .endif
      invoke file_delete,ADDR wfd.cFileName

    @@:                                     ; loop through the rest
      test rv(FindNextFile,hSrch,ADDR wfd), eax
      jz close_file
      invoke SetFileAttributes,ADDR wfd.cFileName,FILE_ATTRIBUTE_NORMAL	
      invoke file_delete,ADDR wfd.cFileName
      .if wfd.dwFileAttributes == FILE_ATTRIBUTE_DIRECTORY
        invoke szCopy,ADDR wfd.cFileName,pbuf
        chdir ADDR wfd.cFileName
        fn scan_files,flag                  ; recurse to next directory level
        rmdir pbuf
      .endif
      jmp @B

    close_file:
      invoke FindClose,hSrch
    .endif

    invoke GetCurrentDirectory,260,pbuf
    invoke SetFileAttributes,pbuf,FILE_ATTRIBUTE_NORMAL	

    .if flag > 1
      chdir ".."                            ; change directory back to next lower directory
      rmdir pbuf
    .endif

    ret

scan_files endp

; 

file_delete proc fname:DWORD

    LOCAL pbuf  :DWORD
    LOCAL buffer[260]:BYTE

    invoke DeleteFile,fname

    mov pbuf, ptr$(buffer)
    invoke GetCurrentDirectory,260,pbuf
    print "deleting: "
    print lcase$(pbuf),"\"
    print lcase$(fname),13,10               ; display the lower case name

    ret

file_delete endp

; 

help proc

    print "KILLTREE.EXE (c) MASM32 1998-2005",13,10
    print "Delete directory tree from specified location",13,10
    print "SYNTAX  : KILLTREE [fully specified directory name]",13,10
    print "EXAMPLE : KILLTREE d:\myjunk\tempfile",13,10
    print "          NOTE Do NOT use a trailing \ at the end of the target directory name",13,10
    print "RESULT  : All file and directories including the target directory are removed",13,10

    ret

help endp

; 

end start





















